// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for license information.
// Code generated by Microsoft (R) TypeSpec Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

#include "certificates_models.hpp"

using namespace Azure::Security::KeyVault::Certificates::_detail::Models;

const DeletionRecoveryLevel DeletionRecoveryLevel::Purgeable{"Purgeable"};
const DeletionRecoveryLevel DeletionRecoveryLevel::RecoverablePurgeable{"Recoverable+Purgeable"};
const DeletionRecoveryLevel DeletionRecoveryLevel::Recoverable{"Recoverable"};
const DeletionRecoveryLevel DeletionRecoveryLevel::RecoverableProtectedSubscription{
    "Recoverable+ProtectedSubscription"};
const DeletionRecoveryLevel DeletionRecoveryLevel::CustomizedRecoverablePurgeable{
    "CustomizedRecoverable+Purgeable"};
const DeletionRecoveryLevel DeletionRecoveryLevel::CustomizedRecoverable{"CustomizedRecoverable"};
const DeletionRecoveryLevel DeletionRecoveryLevel::CustomizedRecoverableProtectedSubscription{
    "CustomizedRecoverable+ProtectedSubscription"};

const JsonWebKeyType JsonWebKeyType::EC{"EC"};
const JsonWebKeyType JsonWebKeyType::ECHsm{"EC-HSM"};
const JsonWebKeyType JsonWebKeyType::Rsa{"RSA"};
const JsonWebKeyType JsonWebKeyType::RsaHsm{"RSA-HSM"};
const JsonWebKeyType JsonWebKeyType::Oct{"oct"};
const JsonWebKeyType JsonWebKeyType::OctHsm{"oct-HSM"};

const JsonWebKeyCurveName JsonWebKeyCurveName::PTwoHundredFiftySix{"P-256"};
const JsonWebKeyCurveName JsonWebKeyCurveName::PThreeHundredEightyFour{"P-384"};
const JsonWebKeyCurveName JsonWebKeyCurveName::PFiveHundredTwentyOne{"P-521"};
const JsonWebKeyCurveName JsonWebKeyCurveName::P256k{"P-256K"};

const KeyUsageType KeyUsageType::DigitalSignature{"digitalSignature"};
const KeyUsageType KeyUsageType::NonRepudiation{"nonRepudiation"};
const KeyUsageType KeyUsageType::KeyEncipherment{"keyEncipherment"};
const KeyUsageType KeyUsageType::DataEncipherment{"dataEncipherment"};
const KeyUsageType KeyUsageType::KeyAgreement{"keyAgreement"};
const KeyUsageType KeyUsageType::KeyCertSign{"keyCertSign"};
const KeyUsageType KeyUsageType::CRLSign{"cRLSign"};
const KeyUsageType KeyUsageType::EncipherOnly{"encipherOnly"};
const KeyUsageType KeyUsageType::DecipherOnly{"decipherOnly"};

const CertificatePolicyAction CertificatePolicyAction::EmailContacts{"EmailContacts"};
const CertificatePolicyAction CertificatePolicyAction::AutoRenew{"AutoRenew"};
